package cz.vsb.kp;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.List;
import java.util.Random;

import com.badlogic.gdx.graphics.Texture;
import com.badlogic.gdx.graphics.g2d.Sprite;
import com.badlogic.gdx.graphics.g2d.SpriteBatch;
import com.badlogic.gdx.math.Rectangle;
import com.badlogic.gdx.physics.box2d.Body;
import com.badlogic.gdx.physics.box2d.BodyDef;
import com.badlogic.gdx.physics.box2d.CircleShape;
import com.badlogic.gdx.physics.box2d.Fixture;
import com.badlogic.gdx.physics.box2d.FixtureDef;
import com.badlogic.gdx.physics.box2d.World;
import com.badlogic.gdx.utils.Array;

public class Drop {

	private static final Random random = new Random();

	private List<String> imgNames = Arrays.asList("aa", "sddd");
	
	private Body body;
	private Texture dropImg;
	private Sprite sprite;
	private float centerX;
	private float centerY;
	private World world;
	private float radius;
	private boolean zmensovani = false;
	private FruitType fruitType;

	public Drop(Texture dropImg, float centerX,
			float centerY, World world) {
		int points = 8447; 
		int tisice = points/1000;
		
//		Integer.toString(he)
//		FruitType[] arrayOfFruitsType = FruitType.values();
//		int fruitTypeSize =arrayOfFruitsType.length;
//		int randomIndexOfFruit = random.nextInt(fruitTypeSize);
//		fruitType = arrayOfFruitsType[randomIndexOfFruit];
		this.dropImg = dropImg;
		radius = 0.2f;
//		radius = fruitType.getSize() / 20f;
		sprite = new Sprite(dropImg);
		sprite.setOriginBasedPosition(dropImg.getWidth() / 200f, dropImg.getHeight() / 200f);
		sprite.setOrigin(0, 0);
		this.centerX = centerX;
		this.centerY = centerY;
		this.world = world;
		createBody();
		body.setLinearVelocity(2 - random.nextFloat() * 2, 0);
	}

	private void createBody() {
		BodyDef def = new BodyDef();
		def.type = BodyDef.BodyType.DynamicBody;
		body = world.createBody(def);
		createNewBodyFixture(radius);
		body.setTransform(centerX, centerY, 0);
//		body.setGravityScale(0);
		body.setUserData(this);
		body.setGravityScale(0.1f);
	}

	private void createNewBodyFixture(float radius) {
		CircleShape poly = new CircleShape();
		poly.setRadius(radius);
		FixtureDef fixtureDef = new FixtureDef();
		fixtureDef.shape = poly;
		fixtureDef.density = 5.5f;
		fixtureDef.friction = 0.1f;
		fixtureDef.restitution = 0.2f; // Make it bounce a little bit
		body.createFixture(fixtureDef);
		poly.dispose();
	}

	public void switchGravityOff() {
		body.setGravityScale(0);
	}
	public void switchGravityOn() {
		body.setGravityScale(0.1f);
	}
	

	public void update() {
		if(zmensovani) {
			zmensi();
		}
	}
	                 
	public boolean isZmensovani() {
		return zmensovani;
	}

	public void setZmensovani(boolean zmensovani) {
		this.zmensovani = zmensovani;
	}

	public void zmensi() {
//		for (Fixture fixture : body.getFixtureList()) {
//			body.destroyFixture(fixture);
//		}
		CircleShape c = (CircleShape)body.getFixtureList().get(0).getShape();
		c.setRadius(c.getRadius()- 0.005f);
		radius = radius - 0.005f;
//		System.out.println("zmenseni" + radius);
//		if(Math.random()> 0.95) {
//			c.setRadius(c.getRadius()+0.5f);
//		}
		if (radius <0.08) {
//			System.out.println("destroy");
			world.destroyBody(body);
		}
	}

	public float getX() {
		return body.getPosition().x;
	}

	public float getY() {
		return body.getPosition().y;
	}

	public float getWidth() {
		return dropImg.getWidth();
	}

	public float getHeigh() {
		return dropImg.getHeight();
	}

	public void draw(SpriteBatch batch) {
		sprite.setSize(radius*2, radius*2);
		sprite.setCenter(body.getPosition().x, body.getPosition().y);
		sprite.setOrigin(sprite.getWidth() / 2, sprite.getHeight() / 2);
		sprite.setRotation((float) (180 / Math.PI * body.getAngle()));
		sprite.draw(batch);
//		batch.draw(dropImg, getX() - getWidth()/2, getY() - getHeigh()/2);
	}
	
}
