package cz.vsb.kp;

import com.badlogic.gdx.graphics.Texture;

public enum FruitType {
	CHERRY(25, "chery.png"), APPLE(30, "apple.png");

	private final int size;
	private final String imgName;
	private Texture img;
	
	private FruitType(int size, String imgName) {
		this.size = size;
		this.imgName = imgName;
	}

	public int getSize() {
		return size;
	}

	public String getImgName() {
		return imgName;
	}
	
	
	public Texture getImg() {
		if(img == null) {
			img = new Texture(imgName);
		}
		return img;
	}
	
}
