package cz.vsb.kp;

import com.badlogic.gdx.Gdx;
import com.badlogic.gdx.Input.Buttons;
import com.badlogic.gdx.Screen;
import com.badlogic.gdx.graphics.OrthographicCamera;
import com.badlogic.gdx.graphics.Texture;
import com.badlogic.gdx.utils.ScreenUtils;

public class MainMenuScreen implements Screen {

	private final DropGame dropGame;
	private OrthographicCamera camera;
	private Texture gardenImg;

	public MainMenuScreen(final DropGame dropGame) {
		this.dropGame = dropGame;
		camera = new OrthographicCamera();
		camera.setToOrtho(false, 1920, 1080);
		gardenImg = new Texture("garden.png");
	}

	@Override
	public void show() {
		// TODO Auto-generated method stub
	}

	@Override
	public void render(float delta) {
		ScreenUtils.clear(0, 0, 0.2f, 1);

		camera.update();
		dropGame.batch.setProjectionMatrix(camera.combined);

		dropGame.batch.begin();
		dropGame.batch.draw(gardenImg, 0, 0);
		dropGame.font.draw(dropGame.batch, "Welcome to Drop!!! ", 100, 150);
		dropGame.font.draw(dropGame.batch, "Tap anywhere to begin!", 100, 100);
		dropGame.batch.end();

		if (Gdx.input.isButtonJustPressed(Buttons.LEFT)) {
			dropGame.setScreen(new GardenScreen(dropGame));
			dispose();
		}
	}

	@Override
	public void resize(int width, int height) {

	}

	@Override
	public void pause() {

	}

	@Override
	public void resume() {

	}

	@Override
	public void hide() {

	}

	@Override
	public void dispose() {
		gardenImg.dispose();
	}

}
